%global momorel 2
%global md5sum_src0 4ae8a38c6b5db9046616ce10a0d551a2 
Name: httpd

### include local configuration
%{?include_specopt}

%global contentdir /var/www
%global mmn 20020903
%{?!suexec_caller_user: %global suexec_caller_user apache}
%{?!suexec_caller_group: %global suexec_caller_group apache}
%{?!suexec_uidmin: %global suexec_uidmin 500}
%{?!suexec_gidmin: %global suexec_gidmin 500}
%{?!suexec_docroot: %global suexec_docroot %{contentdir}}
%define vstring Momonga
%define distro Momonga Linux

Summary: Apache HTTP Server
Version: 2.0.54
Release: %{momorel}m
URL: http://httpd.apache.org/
%NoSource 0 http://archive.apache.org/dist/httpd/httpd-%{version}.tar.bz2 %{md5sum_src0}
Source1: index.html
Source3: httpd.logrotate
Source4: httpd.init
Source6: poweredby.png
Source10: httpd.conf
Source11: ssl.conf
Source12: welcome.conf
Source14: mod_ssl-Makefile.crt
Source15: mod_ssl-Makefile.crl
Source16: ldap.conf
Source17: error-messages.tar.bz2
Source18: manual.conf
Source19: mod_proxy.conf
Source20: mod_dav.conf
# Documentation
Source30: migration.xml
Source31: migration.css
Source32: html.xsl
Source33: README.confd
# official patches

# build/scripts patches
Patch10: httpd-2.0.36-apxs.patch
Patch11: httpd-2.0.51-linkmods.patch
Patch12: httpd-2.0.47-pie.patch
Patch13: httpd-2.0.45-syspcre.patch
Patch14: httpd-2.0.48-vpathinc.patch
# Bug fixes
Patch20: httpd-2.0.45-encode.patch
Patch21: httpd-2.0.45-davetag.patch
Patch22: httpd-2.0.51-ldapshm.patch
Patch23: httpd-2.0.51-shmcb.patch
Patch24: httpd-2.0.46-sslmutex.patch
Patch25: httpd-2.0.46-md5dig.patch
Patch27: httpd-2.0.48-sslpphrase.patch
Patch28: httpd-2.0.48-worker.patch
Patch29: httpd-2.0.48-workerhup.patch
Patch30: httpd-2.0.48-davmisc.patch
Patch32: httpd-2.0.48-vhost.patch
# for mod_iplimitconn
Patch45: apachesrc.diff
# Features/functional changes
Patch70: httpd-2.0.48-release.patch
Patch71: httpd-2.0.40-xfsz.patch
#Patch72: httpd-2.0.40-pod.patch
#Patch73: httpd-2.0.40-noshmht.patch
Patch75: httpd-2.0.48-dynlimit.patch
Patch76: httpd-2.0.48-dynamic.patch
#Patch77: httpd-2.0.48-sslstatus.patch
#Patch78: httpd-2.0.48-corelimit.patch
#Patch80: httpd-2.0.48-distcache.patch
#Patch81: httpd-2.0.48-debuglog.patch
#Patch84: httpd-2.0.51-sslheader.patch
#Patch85: httpd-2.0.51-sslvars2.patch
#Patch86: httpd-2.0.48-rewritessl.patch
#Patch89: httpd-2.0.49-headerssl.patch
Patch91: httpd-2.0.49-suexecmsg.patch
#Patch94: http://www.apache.org/~jorton/ap_splitlfs.diff

License: Apache
Group: System Environment/Daemons
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildPrereq: db4-devel, expat-devel, findutils, perl, pkgconfig, xmlto, pcre-devel, ed
Requires: gawk, findutils, mailcap
Prereq: chkconfig, mktemp, fileutils
Prereq: sh-utils, textutils, shadow-utils
Provides: webserver
Provides: httpd-mmn = %{mmn}

%description
Apache is a powerful, full-featured, efficient, and freely-available
Web server. Apache is also the most popular Web server on the
Internet.

%package devel
Group: Development/Libraries
Summary: Development tools for the Apache HTTP server.
Obsoletes: apache-devel
Requires: libtool, httpd = %{version}-%{release}

%description devel
The httpd-devel package contains the APXS binary and other files
that you need to build Dynamic Shared Objects (DSOs) for Apache.

If you are installing the Apache HTTP server and you want to be
able to compile or develop additional modules for Apache, you need
to install this package.

%package manual
Group: Documentation
Summary: Documentation for the Apache HTTP server.
Obsoletes: secureweb-manual, apache-manual
Requires: httpd = %{version}-%{release}

%description manual
The httpd-manual package contains the complete manual and
reference guide for the Apache HTTP server. The information can
also be found at http://httpd.apache.org/docs/.

%package apr
Group: Development/Libraries
Summary: APR Apache Portability Runtime library

%description apr
APR Apache Portability Runtime library

%package -n mod_ssl
Group: System Environment/Daemons
Summary: SSL/TLS module for the Apache HTTP server
Serial: 1
BuildPrereq: openssl-devel
Prereq: openssl >= 0.9.7b-2m , dev, /bin/cat
Requires: httpd = %{version}-%{release}, make, httpd-mmn = %{mmn}

%description -n mod_ssl
The mod_ssl module provides strong cryptography for the Apache Web
server via the Secure Sockets Layer (SSL) and Transport Layer
Security (TLS) protocols.

%package -n mod_auth_ldap
Group: System Environment/Daemons
Summary: LDAP module for the Apache HTTP server
BuildPrereq: openldap-devel
Requires: httpd = %{version}-%{release}, httpd-mmn = %{mmn}
Obsoletes: auth_ldap

%description -n mod_auth_ldap
The mod_auth_ldap module provides authentication module for the Apache Web
server that allow you to authenticate HTTP client using user entries in a
LDAP directory.

%package suexec
Group: System Environment/Daemons
Summary: suexec binary for the Apache HTTP server
Requires: httpd = %{version}-%{release}

%description suexec
This package includes the /usr/sbin/suexec binary which can be installed
to allow the Apache HTTP server to run CGI programs (and any programs
executed by SSI pages) as a user other than the 'apache' user.

%prep
%setup -q
%patch10 -p0 -b .apxs
%patch11 -p1 -b .linkmods
%patch13 -p1 -b .syspcre
%patch14 -p1 -b .vpathinc

# no -b to prevent droplets in install root
%patch20 -p1
%patch21 -p1 -b .davetag
%patch22 -p1 -b .ldapshm
%patch23 -p1 -b .shmcb
%patch24 -p1 -b .sslmutex
%patch25 -p1 -b .md5dig
%patch27 -p1 -b .sslpphrase
%patch28 -p1 -b .worker
%patch29 -p1 -b .workerhup
%patch30 -p1 -b .davmisc
%patch32 -p1 -b .vhost

%patch45 -p1 -b .limitipconn

%patch71 -p0 -b .xfsz
#%%patch72 -p1 -b .pod
#%%patch73 -p1 -b .noshmht
%patch75 -p1 -b .dynlimit
%patch76 -p1 -b .dynamic
#%%patch77 -p1 -b .sslstatus
#%%patch78 -p1 -b .corelimit
#%%patch80 -p1 -b .distcache
#%%patch81 -p1 -b .debuglog
#%%patch84 -p1 -b .sslheader
##%patch85 -p1 -b .sslvars2
#%%patch86 -p1 -b .rewritessl
#%%patch89 -p1 -b .headerssl
%patch91 -p1 -b .suexecmsg
#%%patch94 -p0 -b .lf

# Patch in vendor/release string
sed "s/@RELEASE@/%{vstring}/" < %{PATCH70} | patch -p1

# Touch mod_ssl expression parser sources to prevent regenerating it
touch modules/ssl/ssl_expr_*.[chyl]

# Safety check: prevent build if defined MMN does not equal upstream MMN.
vmmn=`echo MODULE_MAGIC_NUMBER_MAJOR | cpp -include \`pwd\`/include/ap_mmn.h | grep -v '#'`
if test "x${vmmn}" != "x%{mmn}"; then
   : Error: Upstream MMN is now ${vmmn}, packaged MMN is %{mmn}.
   : Update the mmn macro and rebuild.
   exit 1
fi

# Conditionally enable PIE support
if echo 'static int foo[30000]; int main () { return 0; }' |
   gcc -pie -fpie -O2 -xc - -o pietest &&
   ./pietest; then
%patch12 -p1 -b .pie
  : PIE support enabled
else
  : WARNING: PIE support not enabled
fi

: Building for '%{distro}' with MMN %{mmn} and vendor string '%{vstring}'

rm -f include/pcreposix.h
# regenerate configure scripts
export _POSIX2_VERSION=199209
./buildconf
unset _POSIX2_VERSION

%build
# Limit size of CHANGES to recent history
echo '1,/Changes with Apache MPM/wq' | ed CHANGES

# Before configure; fix location of build dir in generated apxs
%{__perl} -pi -e "s:\@exp_installbuilddir\@:%{_libdir}/httpd/build:g" \
  support/apxs.in
%{__perl} -pi -e "s:\@installbuilddir\@:%{_libdir}/httpd/build:g" \
  srclib/apr/apr-config.in
# update location of migration guide in apachectl
%{__perl} -pi -e "s:\@docdir\@:%{_docdir}/%{name}-%{version}:g" \
        support/apachectl.in

# Build the migration guide
sed 's/@DISTRO@/%{distro}/' < $RPM_SOURCE_DIR/migration.xml > migration.xml
xmlto --skip-validation -x $RPM_SOURCE_DIR/html.xsl html-nochunks migration.xml
cp $RPM_SOURCE_DIR/migration.css . # make %%doc happy

%ifnarch x86_64
CFLAGS="%{optflags} -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64"
%else
CFLAGS="%{optflags}"
%endif
CPPFLAGS="-DSSL_EXPERIMENTAL_ENGINE"
if pkg-config openssl; then
        # configure -C barfs with trailing spaces in CFLAGS
        CPPFLAGS="$CPPFLAGS `pkg-config --cflags openssl | sed 's/ *$//'`"
  SSL_LIBS="`pkg-config --libs openssl`"
fi
export CFLAGS CPPFLAGS SSL_LIBS

function mpmbuild()
{
mpm=$1; shift
mkdir $mpm; pushd $mpm
cat > config.cache <<EOF
ac_cv_func_pthread_mutexattr_setpshared=no
ac_cv_func_sem_open=no
EOF
../configure -C \
  --prefix=%{_sysconfdir}/httpd \
  --exec-prefix=%{_prefix} \
  --bindir=%{_bindir} \
  --sbindir=%{_sbindir} \
  --mandir=%{_mandir} \
  --libdir=%{_libdir} \
  --sysconfdir=%{_sysconfdir}/httpd/conf \
  --includedir=%{_includedir}/httpd \
  --libexecdir=%{_libdir}/httpd/modules \
  --datadir=%{contentdir} \
  --with-installbuilddir=%{_libdir}/httpd/build \
  --without-gdbm --with-berkley-db=%{_libdir} \
  --with-mpm=$mpm \
  --enable-suexec --with-suexec \
  --with-suexec-caller=%{suexec_caller_user} \
  --with-suexec-docroot=%{suexec_docroot} \
  --with-suexec-logfile=%{_localstatedir}/log/httpd/suexec.log \
  --with-suexec-bin=%{_sbindir}/suexec \
  --with-suexec-uidmin=%{suexec_uidmin} --with-suexec-gidmin=%{suexec_gidmin} \
  $*
%make
popd
}

# Only bother enabling optional modules for main build.
mpmbuild prefork --enable-mods-shared=all \
  --enable-ssl --with-ssl \
  --enable-deflate \
  --enable-proxy --enable-proxy-connect \
  --enable-proxy-http --enable-proxy-ftp \
  --enable-cache --enable-mem-cache \
  --enable-file-cache --enable-disk-cache \
  --with-ldap --enable-ldap --enable-auth-ldap \
  --enable-cgid \
  --enable-forward \
  --enable-logio

# To prevent most modules being built statically into httpd.worker,
# easiest way seems to be enable them shared.
mpmbuild worker --enable-mods-shared=all

# Verify that the same modules were built into the two httpd binaries
./prefork/httpd -l | grep -v prefork > prefork.mods
./worker/httpd -l | grep -v worker > worker.mods
if ! diff -u prefork.mods worker.mods; then
  : Different modules built into httpd binaries, will not proceed
  exit 1
fi

%install
rm -rf %{buildroot}

# Classify ab and logresolve as section 1 commands, as they are in /usr/bin
mv docs/man/ab.8 docs/man/ab.1
sed -e "1s/logresolve 8/logresolve 1/" \
  < docs/man/logresolve.8 > docs/man/logresolve.1
rm docs/man/logresolve.8

pushd prefork
make DESTDIR=%{buildroot} install
popd
# install worker binary
install -m 755 worker/.libs/httpd %{buildroot}%{_sbindir}/httpd.worker

# link to system pcreposix.h
ln -s ../pcreposix.h $RPM_BUILD_ROOT%{_includedir}/httpd/pcreposix.h

# install conf file/directory
mkdir %{buildroot}%{_sysconfdir}/httpd/conf.d
install -m 644 $RPM_SOURCE_DIR/README.confd \
   %{buildroot}%{_sysconfdir}/httpd/conf.d/README
install -m 644 $RPM_SOURCE_DIR/ssl.conf \
   %{buildroot}%{_sysconfdir}/httpd/conf.d/ssl.conf.dist
install -m 644 $RPM_SOURCE_DIR/welcome.conf \
   %{buildroot}%{_sysconfdir}/httpd/conf.d/welcome.conf
install -m 644 $RPM_SOURCE_DIR/ldap.conf \
   %{buildroot}%{_sysconfdir}/httpd/conf.d/ldap.conf.dist
install -m 644 $RPM_SOURCE_DIR/mod_proxy.conf \
   %{buildroot}%{_sysconfdir}/httpd/conf.d/mod_proxy.conf.dist
install -m 644 $RPM_SOURCE_DIR/mod_dav.conf \
   %{buildroot}%{_sysconfdir}/httpd/conf.d/mod_dav.conf.dist
install -m 644 $RPM_SOURCE_DIR/manual.conf \
   %{buildroot}%{_sysconfdir}/httpd/conf.d/manual.conf.dist

rm %{buildroot}%{_sysconfdir}/httpd/conf/*.conf
install -m 644 $RPM_SOURCE_DIR/httpd.conf \
   %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf

# mod_ssl bits
for suffix in crl crt csr key prm; do
   mkdir %{buildroot}%{_sysconfdir}/httpd/conf/ssl.${suffix}
done

# Makefiles for certificate management
for ext in crt crl; do
  install -m 644 $RPM_SOURCE_DIR/mod_ssl-Makefile.${ext} \
        %{buildroot}%{_sysconfdir}/httpd/conf/ssl.${ext}/Makefile.${ext}
done
ln -s ../../../usr/share/ssl/certs/Makefile %{buildroot}/etc/httpd/conf

# for holding mod_dav lock database
mkdir -p %{buildroot}%{_localstatedir}/lib/dav

# create a prototype session cache
mkdir -p %{buildroot}%{_localstatedir}/cache/mod_ssl
touch %{buildroot}%{_localstatedir}/cache/mod_ssl/scache.{dir,pag,sem}

# create cache root
mkdir %{buildroot}%{_localstatedir}/cache/mod_proxy

# move utilities to /usr/bin
mv %{buildroot}%{_sbindir}/{ab,htdbm,logresolve,htpasswd,htdigest} \
   %{buildroot}%{_bindir}

# make libtool a symlink
mv %{buildroot}%{contentdir}/build %{buildroot}%{_libdir}/httpd/build
rm %{buildroot}%{_libdir}/httpd/build/libtool
# point to the correct libtool
ln -s ../../../..%{_bindir}/libtool %{buildroot}%{_libdir}/httpd/build/libtool

# Install and sanitize config_vars file: relocate the build directory into
# libdir; reference correct libtool; fix EXTRA_INCLUDES
sed -e "s|%{contentdir}/build|%{_libdir}/httpd/build|g" \
    -e "/AP_LIBS/d" -e "/abs_srcdir/d" \
    -e "/^LIBTOOL/s|/[^ ]*/libtool|%{_bindir}/libtool|" \
    -e "/^installbuilddir/s| = .*$| = /etc/httpd/build|" \
    -e "/^EXTRA_INCLUDES/s|-I$RPM_BUILD_DIR[^ ]* ||g" \
  < prefork/build/config_vars.mk \
  > %{buildroot}%{_libdir}/httpd/build/config_vars.mk
install -m 644 build/special.mk \
    %{buildroot}%{_libdir}/httpd/build/special.mk

# Make the MMN accessible to module packages
echo %{mmn} > %{buildroot}%{_includedir}/httpd/.mmn

# docroot
mkdir %{buildroot}%{contentdir}/html
%{__tar} jxf %{SOURCE17} -C  %{buildroot}%{contentdir}

# remove manual sources
find %{buildroot}%{contentdir}/manual \( \
    -name \*.xml -o -name \*.xml.* -o -name \*.ent -o -name \*.xsl -o -name \*.dtd \
    \) -print0 | xargs -0 rm -f

install -m 644 %{SOURCE6} \
  %{buildroot}%{contentdir}/icons

# logs
rmdir %{buildroot}%{_sysconfdir}/httpd/logs
mkdir -p %{buildroot}%{_localstatedir}/log/httpd

# symlinks for /etc/httpd
ln -s ../..%{_localstatedir}/log/httpd %{buildroot}/etc/httpd/logs
ln -s ../..%{_localstatedir}/run %{buildroot}/etc/httpd/run
ln -s ../..%{_libdir}/httpd/modules %{buildroot}/etc/httpd/modules
ln -s ../..%{_libdir}/httpd/build %{buildroot}/etc/httpd/build

# install SYSV init stuff
mkdir -p %{buildroot}%{_initscriptdir}
install -m755 $RPM_SOURCE_DIR/httpd.init \
  %{buildroot}%{_initscriptdir}/httpd
%{__perl} -pi -e "s:\@docdir\@:%{_docdir}/%{name}-%{version}:g" \
  %{buildroot}%{_initscriptdir}/httpd

# install log rotation stuff
mkdir -p %{buildroot}/etc/logrotate.d
install -m644 $RPM_SOURCE_DIR/httpd.logrotate \
  %{buildroot}/etc/logrotate.d/httpd

# fix man page paths
sed -e "s|/usr/local/apache2/conf/httpd.conf|/etc/httpd/conf/httpd.conf|" \
    -e "s|/usr/local/apache2/conf/mime.types|/etc/mime.types|" \
    -e "s|/usr/local/apache2/conf/magic|/etc/httpd/conf/magic|" \
    -e "s|/usr/local/apache2/logs/error_log|/var/log/httpd/error_log|" \
    -e "s|/usr/local/apache2/logs/access_log|/var/log/httpd/access_log|" \
    -e "s|/usr/local/apache2/logs/httpd.pid|/var/run/httpd.pid|" \
    -e "s|/usr/local/apache2|/etc/httpd|" < docs/man/httpd.8 \
  > %{buildroot}%{_mandir}/man8/httpd.8

# Remove unpackaged files
#rm -f %{buildroot}%{_libdir}/*.exp \
#      %{buildroot}/etc/httpd/conf/mime.types \
#      %{buildroot}%{_libdir}/httpd/modules/*.exp \
#      %{buildroot}%{_libdir}/httpd/build/config.nice \
#      %{buildroot}%{_bindir}/ap?-config \
#      %{buildroot}%{_sbindir}/{checkgid,dbmmanage,envvars*} \
#      %{buildroot}%{contentdir}/htdocs/* \
#      %{buildroot}%{_mandir}/man1/dbmmanage.* \
#      %{buildroot}%{contentdir}/cgi-bin/*

# Remove unpackaged files
rm -f  %{buildroot}/etc/httpd/conf/mime.types \
       %{buildroot}%{_sbindir}/{checkgid,dbmmanage,envvars*} \
       %{buildroot}%{contentdir}/htdocs/* \
       %{buildroot}%{_mandir}/man1/dbmmanage.* \
       %{buildroot}%{contentdir}/cgi-bin/*

# remove unwanted files.
rm -f %{buildroot}/usr/include/httpd/.mmn
#rm -rf %{buildroot}%{contentdir}/htdocs
#rm -rf %{buildroot}%{contentdir}/cgi-bin/printenv
#rm -rf %{buildroot}%{contentdir}/cgi-bin/test-cgi

# Make suexec a+rw so it can be stripped.  %%files lists real permissions
chmod 755 %{buildroot}%{_sbindir}/suexec

%pre
# Add the "apache" user
/usr/sbin/useradd -c "Apache" -u 48 \
  -s /sbin/nologin -r -d %{contentdir} apache 2> /dev/null || :

if [ -f /usr/sbin/suexec ]; then
  rm -f /etc/httpd/conf/suexec.perm
  touch /etc/httpd/conf/suexec.perm
  chmod --reference /usr/sbin/suexec /etc/httpd/conf/suexec.perm
fi

%triggerpostun -- apache < 2.0
/sbin/chkconfig --add httpd

%post
# Register the httpd service
/sbin/chkconfig --add httpd

if [ -f /etc/httpd/conf/suexec.perm ]; then
  chmod --reference /etc/httpd/conf/suexec.perm /usr/sbin/suexec
  rm -f /etc/httpd/conf/suexec.perm
fi

%preun
if [ $1 = 0 ]; then
  /sbin/service httpd stop > /dev/null 2>&1
  /sbin/chkconfig --del httpd
fi

%post -n mod_ssl
/sbin/ldconfig ### is this needed?
umask 077

if [ ! -f %{_sysconfdir}/httpd/conf/ssl.key/server.key ] ; then
%{_bindir}/openssl genrsa -rand /proc/apm:/proc/cpuinfo:/proc/dma:/proc/filesystems:/proc/interrupts:/proc/ioports:/proc/pci:/proc/rtc:/proc/uptime 1024 >%{_sysconfdir}/httpd/conf/ssl.key/server.key 2> /dev/null
fi

FQDN=`hostname`
if [ "x${FQDN}" = "x" ]; then
   FQDN=localhost.localdomain
fi

if [ ! -f %{_sysconfdir}/httpd/conf/ssl.crt/server.crt ] ; then
cat << EOF | %{_bindir}/openssl req -new -key %{_sysconfdir}/httpd/conf/ssl.key/server.key -x509 -days 365 -out %{_sysconfdir}/httpd/conf/ssl.crt/server.crt 2>/dev/null
--
SomeState
SomeCity
SomeOrganization
SomeOrganizationalUnit
${FQDN}
root@${FQDN}
EOF
fi

#%%check
## Check the built modules are all PIC
#if readelf -d %{buildroot}%{_libdir}/httpd/modules/*.so | grep TEXTREL; then
#   : modules contain non-relocatable code
#   exit 1
#fi

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)

%doc ABOUT_APACHE README CHANGES LICENSE VERSIONING NOTICE
%doc migration.html migration.css

%dir %{_sysconfdir}/httpd
%{_sysconfdir}/httpd/modules
%{_sysconfdir}/httpd/logs
%{_sysconfdir}/httpd/run
%dir %{_sysconfdir}/httpd/conf
%config(noreplace) %{_sysconfdir}/httpd/conf/httpd.conf
%config(noreplace) %{_sysconfdir}/httpd/conf.d/welcome.conf
%config(noreplace) %{_sysconfdir}/httpd/conf/magic

%config %{_sysconfdir}/logrotate.d/httpd
%config %{_initscriptdir}/httpd

%dir %{_sysconfdir}/httpd/conf.d
%{_sysconfdir}/httpd/conf.d/README

%{_bindir}/ab
%{_bindir}/ht*
%{_bindir}/logresolve
%{_sbindir}/httpd
%{_sbindir}/httpd.worker
%{_sbindir}/apachectl
%{_sbindir}/rotatelogs

%dir %{_libdir}/httpd
%dir %{_libdir}/httpd/modules
# everything but mod_ssl.so
# mod_auth_ldap.so mod_ldap.so util_ldap.so:
%{_libdir}/httpd/modules/mod*.so
%exclude %{_libdir}/httpd/modules/mod_ssl.so
%exclude %{_libdir}/httpd/modules/mod_auth_ldap.so
%exclude %{_libdir}/httpd/modules/mod_ldap.so

%dir %{contentdir}
%dir %{contentdir}/cgi-bin
%dir %{contentdir}/html
%dir %{contentdir}/icons
%dir %{contentdir}/error
%dir %{contentdir}/error/include
%dir %{contentdir}/error/styles
%{contentdir}/icons/*
%{contentdir}/error/ErrorCode
%{contentdir}/error/README*
%{contentdir}/error/noindex.html
%config(noreplace) %{contentdir}/error/*.var
%config(noreplace) %{contentdir}/error/include/*.html
%config(noreplace) %{contentdir}/error/styles/*.css

%attr(0700,root,root) %dir %{_localstatedir}/log/httpd
%attr(0700,apache,apache) %dir %{_localstatedir}/lib/dav
%attr(0700,apache,apache) %dir %{_localstatedir}/cache/mod_proxy
%config(noreplace) %{_sysconfdir}/httpd/conf.d/mod_dav.conf.dist
%config(noreplace) %{_sysconfdir}/httpd/conf.d/mod_proxy.conf.dist

%{_mandir}/man?/*
%exclude %{_mandir}/man8/apxs.8*
%exclude %{_mandir}/man8/suexec.8*

%files manual
%defattr(-,root,root)
%{contentdir}/manual
%config(noreplace) %{_sysconfdir}/httpd/conf.d/manual.conf.dist

%files -n mod_ssl
%defattr(-,root,root)
%{_libdir}/httpd/modules/mod_ssl.so
%config(noreplace) %{_sysconfdir}/httpd/conf.d/ssl.conf.dist
%attr(0700,root,root) %dir %{_sysconfdir}/httpd/conf/ssl.*
%config %{_sysconfdir}/httpd/conf/Makefile
%config %{_sysconfdir}/httpd/conf/ssl.*/*
%attr(0700,apache,root) %dir %{_localstatedir}/cache/mod_ssl
%attr(0600,apache,root) %ghost %{_localstatedir}/cache/mod_ssl/scache.dir
%attr(0600,apache,root) %ghost %{_localstatedir}/cache/mod_ssl/scache.pag
%attr(0600,apache,root) %ghost %{_localstatedir}/cache/mod_ssl/scache.sem

%files -n mod_auth_ldap
%defattr(-,root,root)
%{_libdir}/httpd/modules/mod_auth_ldap.so
%{_libdir}/httpd/modules/mod_ldap.so
%config(noreplace) %{_sysconfdir}/httpd/conf.d/ldap.conf.dist

%files devel
%defattr(-,root,root)
%{_includedir}/httpd
%exclude %{_includedir}/httpd/apr*.h
%exclude %{_includedir}/httpd/apu*.h
%{_sysconfdir}/httpd/build
%{_libdir}/httpd/modules/httpd.exp
%{_sbindir}/apxs
%{_mandir}/man8/apxs.8*
%{_libdir}/httpd/build
%exclude %{_libdir}/httpd/build/apr*.mk

%files apr
%defattr(-,root,root)
%{_bindir}/ap?-config
%{_includedir}/httpd/apr*.h
%{_includedir}/httpd/apu*.h
%{_libdir}/libapr*.so
%{_libdir}/libapr*.*a
%{_libdir}/libapr*.so.*
%{_libdir}/apr*.exp
%{_libdir}/httpd/build/apr*.mk

%files suexec
%defattr(-,root,root)
%attr(4510,root,%{suexec_caller_group}) %{_sbindir}/suexec
%{_mandir}/man8/suexec.8*

%changelog
* Sat Apr 23 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.54-2m)
- modify httpd-devel files include /etc/httpd/build

* Tue Apr 19 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.54-1m)
- *) Remove formatting characters from ap_log_error() calls.  These
     were escaped as fallout from CAN-2003-0020.

* Thu Apr  7 2005 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.53-3m)
- remove duplicated files

* Mon Feb 28 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.53-2m)
- no recreate png

* Tue Feb  8 2005 Mitsuru Shimamura <smbd@momonga-linux.org>
- (2.0.53-1m)
- up to 2.0.53. large file support.

* Tue Feb  8 2005 Mitsuru Shimamura <smbd@momonga-linux.org>
- (2.0.52-7m)
- enable specopt for suexec

* Sun Feb 06 2005 mutecat <mutecat@momonga-linux.org>
- (2.0.52-6m)
- link correction pcreposix.h

* Sun Jan 16 2005 Toru Hoshina <t@momonga-linux.org>
- (2.0.52-5m)
- enable x86_64.

* Sun Nov 28 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.52-4m)
- sync STABLE_1
  * Wed Oct 27 2004 YAMAZAKI Makoto <zaki@zakky.org>
  - (2.0.50-7m)
  - indicated the location of db4 explicitly in order to be
    correctly linked with db4.
    
  * Fri Oct  1 2004 KOMATSU Shinichiro <koma2@momonga-linux.org>
  - (2.0.50-6m)
  - apply the patches to fix CAN-2004-0747, CAN-2004-0748,
    CAN-2004-0751, CAN-2004-0786, CAN-2004-0809
  - change dist site to archive.apache.org
  - README.confd was listed twice, so remove one.

* Fri Nov 12 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.52-3m)
- security fix (CAN-2004-0942)

* Mon Oct 18 2004 Shigeyuki Yamashita <shige@momonga-linux.org>
- (2.0.52-2m)
- security fix (CAN-2004-0885)
  reference -> http://cve.mitre.org/cgi-bin/cvename.cgi?name=CAN-2004-0885
  patch92

* Thu Sep 30 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.52-1m)
- security fix (CAN-2004-0811)
- remove 'httpd-2.0.48-suexeclibs.patch' that was merged

* Mon Sep 27 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.51-2m)
- apply 'CAN-2004-0811.patch'

* Thu Sep 16 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.51-1m)
- including security fixes

* Sun Jul 25 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.50-4m)
- seperate mod_proxy.conf/mod_dav.conf/manual.conf

* Wed Jul 21 2004 Hiroyuki Koga <kuma@momonga-linux.org>
- (2.0.50-3m)
- modify httpd.conf (gif -> png, AddDefaultCharset UTF-8 -> Off)

* Sun Jul 18 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.50-2m)
- import patch from FC2

* Tue Jun 29 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.0.50-1m)
- including security fixes

* Tue Jun 29 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.49-8m)
- apply 'CAN-2004-0493.patch'

* Mon Jun 28 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.49-7m)
- rebuild against db4.2

* Sat May 22 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.0.49-6m)
- adapt specopt suexec_caller_user and suexec_caller_group value
  requested by [Momonga-devel.ja:02526]

* Fri May 21 2004 Yasuo Ohgaki <yohgaki@momonga-linux.org>
- (2.0.49-5m)
- work around sig HUP problem with PHP
- add LoadModule for PHP

* Fri May  7 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (2.0.49-4m)
- revise ssl.conf
- use /dev/urandom instead of /dev/random

* Tue May  4 2004 Toru Hoshina <t@momonga-linux.org>
- (2.0.49-3m)
- %%{_initscriptdir}

* Fri Apr 16 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (2.0.49-2m)
- add --with-berleley-db to configure options

* Sun Mar 21 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.49-1m)
- including security fixes

* Sun Mar 21 2004 Toru Hoshina <t@momonga-linux.org>
- (2.0.48-8m)
- modoshisugi.

* Sat Mar 20 2004 Toru Hoshina <t@momonga-linux.org>
- (2.0.48-7m)
- revised spec for enabling rpm 4.2.

* Tue Mar  2 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (2.0.48-6m)
- enable SSL_EXPERIMENTAL

* Sun Feb 22 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.48-5m)
- make both prefork mpm version and worker mpm version

* Sun Feb 22 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.48-4m)
- now build with '--with-mpm=worker'

* Mon Nov 10 2003 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.48-3m)
- rebuild against gdbm-1.8.0

* Sat Nov  1 2003 YAMAZAKI Makoto <zaki@zakky.org>
- (2.0.48-2m)
- revise httpd.conf to prohibit DocumentRoot directory listing
    see http://www.st.ryukoku.ac.jp/~kjm/security/ml-archive/bugtraq/2003.10/msg00281.html

* Tue Oct 28 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.48-1m)
- security fixes

* Mon Oct 27 2003 zunda <zunda at freeshell.org>
- (2.0.47-5m)
- [Momonga-devel.ja:02161] ssl.conf seems to require to be read before
  php.conf or ruby.conf: /etc/httpd/conf.d/ssl.conf is renamed to
  /etc/httpd/conf.d/00ssl.conf. server/config.c takes care of sorting
  filenames alphanumerically in ap_process_resource_config(), right?

* Sat Oct 04 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.0.47-4m)
- change License: to Apache
- adapt the License: preamble for the Momonga Linux license
  expression unification policy (draft)

* Wed Jul 30 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.47-3m)
- add 'mod_limitipconn-0.22/apachesrc.diff'
- http://dominia.org/djao/limitipconn2.html

* Mon Jul 28 2003 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.47-2m)
- modify certs dir

* Wed Jul  9 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.47-1m)
- security fixes

* Thu Jun 19 2003 Tsuromu Yasuda <tom@tom.homelinux.org>
- (2.0.46-4m)
  fix apr-config (installbuilddir)

* Sun Jun 15 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (2.0.46-3m)
- with installbuilddir

* Mon Jun  9 2003 Shigeyuki Yamashita <shige@cty-net.ne.jp>
- (2.0.46-2m)
- error message's styles directory moved
   from "%{contentdir}/html/styles" to "%{contentdir}/errors/styles".

* Wed May 28 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.46-1m)
- security fixes

* Sun May 18 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (2.0.45-5m)
- export _POSIX2_VERSION=199209 in %%prep section

* Thu May  1 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2.0.45-4m)
  separated apr

* Sat Apr 26 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2.0.45-3m)
  added apr and apr-util to devel

* Tue Apr 22 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2.0.45-2m)
  fix requires.
  fix symlink.

* Tue Apr  1 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.45-1m)
- minor security fixes

* Sun Mar 30 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (2.0.44-8m)
- specoptize

* Sun Mar 16 2003 Shigeyuki Yamashita <shige@cty-net.ne.jp>
- (2.0.44-7m)
- add japanize error messages and error page's style.

* Sat Mar  8 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2.0.44-6m)
  rebuild against openssl 0.9.7a

* Mon Feb 17 2003 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.44-5m)
- keep permission of /usr/sbin/suexec

* Mon Feb 17 2003 smbd <smbd.homelinux.org>
- (2.0.44-4m)
- fix mistake (delete powerdby.png)

* Mon Feb 17 2003 smbd <smbd.homelinux.org>
- (2.0.44-3m)
- make png transport and delete gif icons

* Fri Feb 14 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.44-2m)
- revise %files

* Fri Feb 14 2003 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.44-1m)
- upgrade to 2.0.44
- add configure option --with-ldap --enable-ldap --enable-auth-ldap

* Thu Jan 16 2003 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.43-1m)
- import from rawhide and update to 2.0.43

* Fri Jan  3 2003 Joe Orton <jorton@redhat.com> 2.0.40-15
- fix possible infinite recursion in config dir processing (#77206)
- fix memory leaks in request body processing (#79282)

* Thu Dec 12 2002 Joe Orton <jorton@redhat.com> 2.0.40-14
- remove unstable shmht session cache from mod_ssl
- get SSL libs from pkg-config if available (Nalin Dahyabhai)
- stop "apxs -a -i" from inserting AddModule into httpd.conf (#78676)

* Wed Nov  6 2002 Joe Orton <jorton@redhat.com> 2.0.40-13
- fix location of installbuilddir in apxs when libdir!=/usr/lib

* Wed Nov  6 2002 Joe Orton <jorton@redhat.com> 2.0.40-12
- pass libdir to configure; clean up config_vars.mk
- package instdso.sh, fixing apxs -i (#73428)
- prevent build if upstream MMN differs from mmn macro
- remove installed but unpackaged files

* Wed Oct  9 2002 Joe Orton <jorton@redhat.com> 2.0.40-11
- correct SERVER_NAME encoding in i18n error pages (thanks to Andre Malo)

* Wed Oct  9 2002 Joe Orton <jorton@redhat.com> 2.0.40-10
- fix patch for CAN-2002-0840 to also cover i18n error pages

* Wed Oct  2 2002 Joe Orton <jorton@redhat.com> 2.0.40-9
- security fixes for CAN-2002-0840 and CAN-2002-0843
- fix for possible mod_dav segfault for certain requests

* Tue Sep 24 2002 Gary Benson <gbenson@redhat.com>
- updates to the migration guide

* Wed Sep  4 2002 Nalin Dahyabhai <nalin@redhat.com> 2.0.40-8
- link httpd with libssl to avoid library loading/unloading weirdness

* Tue Sep  3 2002 Joe Orton <jorton@redhat.com> 2.0.40-7
- add LoadModule lines for proxy modules in httpd.conf (#73349)
- fix permissions of conf/ssl.*/ directories; add Makefiles for
  certificate management (#73352)

* Mon Sep  2 2002 Joe Orton <jorton@redhat.com> 2.0.40-6
- provide "httpd-mmn" to manage module ABI compatibility

* Sun Sep  1 2002 Joe Orton <jorton@redhat.com> 2.0.40-5
- fix SSL session cache (#69699)
- revert addition of LDAP support to apr-util

* Mon Aug 26 2002 Joe Orton <jorton@redhat.com> 2.0.40-4
- set SIGXFSZ disposition to "ignored" (#69520)
- make dummy connections to the first listener in config (#72692)

* Mon Aug 26 2002 Joe Orton <jorton@redhat.com> 2.0.40-3
- allow "apachectl configtest" on a 1.3 httpd.conf
- add mod_deflate
- enable LDAP support in apr-util
- don't package everything in /var/www/error as config(noreplace)

* Wed Aug 21 2002 Bill Nottingham <notting@redhat.com> 2.0.40-2
- add trigger (#68657)

* Mon Aug 12 2002 Joe Orton <jorton@redhat.com> 2.0.40-1
- update to 2.0.40

* Wed Jul 24 2002 Joe Orton <jorton@redhat.com> 2.0.36-8
- improve comment on use of UserDir in default config (#66886)

* Wed Jul 10 2002 Joe Orton <jorton@redhat.com> 2.0.36-7
- use /sbin/nologin as shell for apache user (#68371)
- add patch from CVS to fix possible infinite loop when processing
  internal redirects

* Wed Jun 26 2002 Gary Benson <gbenson@redhat.com> 2.0.36-6
- modify init script to detect 1.3.x httpd.conf's and direct users
  to the migration guide

* Tue Jun 25 2002 Gary Benson <gbenson@redhat.com> 2.0.36-5
- patch apachectl to detect 1.3.x httpd.conf's and direct users
  to the migration guide
- ship the migration guide

* Fri Jun 21 2002 Joe Orton <jorton@redhat.com>
- move /etc/httpd2 back to /etc/httpd
- add noindex.html page and poweredby logo; tweak default config
  to load noindex.html if no default "/" page is present.
- add patch to prevent mutex errors on graceful restart

* Fri Jun 21 2002 Tim Powers <timp@redhat.com> 2.0.36-4
- automated rebuild

* Wed Jun 12 2002 Joe Orton <jorton@redhat.com> 2.0.36-3
- add patch to fix SSL mutex handling

* Wed Jun 12 2002 Joe Orton <jorton@redhat.com> 2.0.36-2
- improved config directory patch

* Mon May 20 2002 Joe Orton <jorton@redhat.com>
- initial build; based heavily on apache.spec and mod_ssl.spec
- fixes: #65214, #58490, #57376, #61265, #65518, #58177, #57245
